# -*- coding: utf-8 -*-
from setuphelpers import *
import platform,json

uninstallkey = []

# Declaring specific app values (TO CHANGE)
bin_name = 'MarkdownEditSetup%s.msi'
bin_end = '.msi'


def install():
    print('installing')

    # Declaring specific app values
    package_version = control['version'].split('-',1)[0]
    impacted_process = control['impacted_process']

    install_msi_if_needed(bin_name % package_version
        ,min_version=package_version
        ,killbefore=impacted_process)


def update_package():
    print('Download/Update package content from upstream binary sources')

    # Getting proxy informations from WAPT settings
    proxy = {}
    if platform.system()=='Windows' and isfile(makepath(application_data(),'waptconsole','waptconsole.ini')):
        proxywapt = inifile_readstring(makepath(user_local_appdata(),'waptconsole','waptconsole.ini'),'global','http_proxy')
        if proxywapt :
            proxy = {'http':proxywapt,'https':proxywapt}

    # Specific app values
    app_name = control.name
    url_api = 'https://api.github.com/repos/mike-ward/Markdown-Edit/releases/latest'

    # Getting latest informations from Github API
    json_load = json.loads(wgets(url_api,proxies=proxy))

    for download in json_load['assets']:
        if download['browser_download_url'].endswith(bin_end):
            url_dl = download['browser_download_url']
            break

    version = (json_load['tag_name']).replace('v','')
    latest_bin = bin_name % version

    print('Latest ' + app_name + ' version is: ' + version)
    print('Download url is: ' + url_dl)

    # Downloading latest binaries
    if not isfile(latest_bin):
        print('Downloading: ' + latest_bin)
        wget(url_dl,latest_bin,proxies=proxy)

		# Change version of the package
        pe = PackageEntry().load_control_from_wapt('.')
        pe.version = '%s-%s'%(version,int(pe.version.split('-',1)[1])+1)
        pe.save_control_to_wapt('.')
        print('Changing version to ' + pe.version + ' in WAPT\\control')
        print('Update package done. You can now build-upload your package')
    else:
        print('This package is already up-to-date')

    # Deleting outdated binaries
    for bin_in_dir in glob.glob('*.exe') or glob.glob('*.msi'):
        if bin_in_dir != latest_bin :
            print('Outdated binary: ' + bin_in_dir + ' Deleted')
            remove_file(bin_in_dir)




